MODULE GripControl

    PROC SetVel(num velocity,num delay)
        VAR rawbytes raw_data;
        VAR dnum velocity_coded;

        SetGO GRIP_go_Cmd,0;
        ClearRawBytes raw_data;
        PackRawBytes velocity,raw_data,1,\Float4;
        UnpackRawBytes raw_data,1,velocity_coded\IntX:=DINT;
        SetGO GRIP_go_DLen,5;
        SetGO GRIP_go_Data,velocity_coded;
        SetGO\SDelay:=0,GRIP_go_Cmd,0xa0;
        WaitTime delay;
    ENDPROC

	PROC GripMovPos(num position,num delay)
        VAR rawbytes raw_data;
        VAR dnum position_coded;

        SetGO GRIP_go_Cmd, 0;
        ClearRawBytes raw_data;
        PackRawBytes position, raw_data, 1,  \Float4;
        UnpackRawBytes raw_data, 1, position_coded \IntX:=DINT;
        SetGO GRIP_go_DLen, 5;
        SetGO GRIP_go_Data,position_coded;
        SetGO \SDelay:=0, GRIP_go_Cmd, 0xb0;
        WaitTime delay;
    ENDPROC

    PROC GripMovGrip(num current,num delay)
        VAR rawbytes raw_data;
        VAR dnum current_coded;
       
        SetGO GRIP_go_Cmd,0;
        SetGO GRIP_go_Cmd,0;
        ClearRawBytes raw_data;
        PackRawBytes current,raw_data,1,\Float4;
        UnpackRawBytes raw_data,1,current_coded\IntX:=UDINT;
        SetGO GRIP_go_DLen,5;
        SetGO GRIP_go_Data,current_coded;
        SetGO\SDelay:=0,GRIP_go_Cmd,0xb7;
        WaitTime delay;

        SetGO GRIP_go_DLen,1;
        SetGO GRIP_go_Cmd,0x8b;
    ENDPROC

    PROC GripMovCur(num current,num delay)
        VAR rawbytes raw_data;
        VAR dnum current_coded;

        SetGO GRIP_go_Cmd,0;
        ClearRawBytes raw_data;
        PackRawBytes current,raw_data,1,\Float4;
        UnpackRawBytes raw_data,1,current_coded\IntX:=UDINT;
        SetGO GRIP_go_DLen,5;
        SetGO GRIP_go_Data,current_coded;
        SetGO\SDelay:=0,GRIP_go_Cmd,0xb3;
        WaitTime delay;

        !SetGO GRIP_go_DLen,1;
        !SetGO GRIP_go_Cmd,0x8b;
        !WaitTime delay;
        sendAck delay;
    ENDPROC
    
    PROC sendAck(num delay)
        SetGO GRIP_go_DLen,1;
        SetGO GRIP_go_Cmd,0x8b;
        
        WaitTime delay;
    ENDPROC
      
        
    

ENDMODULE