close all;


figure;
axes('FontSize',14);
plot(ypd(:,1),ypd(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$y(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(ypd_err(:,1),ypd_err(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$y(t) - y_{r}(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(ypd_dot(:,1),ypd_dot(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$\dot y(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(upd(:,1),upd(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$u(t)$','FontSize',16,'Interpreter','Latex');

