close all;

figure;
axes('FontSize',14);
plot(k(:,1),k(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$\hat k(t)$','FontSize',16,'Interpreter','Latex');



figure;
axes('FontSize',14);
plot(sigma(:,1),sigma(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$\hat\sigma(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(y(:,1),y(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$y(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(y_err(:,1),y_err(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$y(t) - y_{r}(t)$','FontSize',16,'Interpreter','Latex');



figure;
axes('FontSize',14);
plot(y_dot(:,1),y_dot(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$\dot y(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(y_int(:,1),y_int(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$v(t)$','FontSize',16,'Interpreter','Latex');

figure;
axes('FontSize',14);
plot(u(:,1),u(:,2),'b-','LineWidth',2);
grid;
xlabel('$t,\,sec$','FontSize',16,'Interpreter','Latex');
ylabel('$u(t)$','FontSize',16,'Interpreter','Latex');

